package org.openxma.dsl.platform.exceptions;


/**
 * An application exception communicates an expected condition demanding an alternative response
 * from a business method.<br/>
 * Error code and a default message are always required when creating an ApplicationException.
 * 
 * @see {@link ErrorCodedException} for base features
 */
public class ApplicationException extends ErrorCodedException {

    private static final long serialVersionUID = 1L;


    public ApplicationException(String errorCode, String defaultMessage) {
        super(errorCode, defaultMessage);
    }

    public ApplicationException(String errorCode, Object[] messageArgs, String defaultMessage) {
        super(errorCode, messageArgs, defaultMessage);
    }

    public ApplicationException(String errorCode, Throwable detail, String defaultMessage) {
        super(errorCode, detail, defaultMessage);
    }

    public ApplicationException(String errorCode, Object[] messageArgs, Throwable detail, String defaultMessage) {
        super(errorCode, messageArgs, detail, defaultMessage);
    }

}
