package org.openxma.dsl.platform.hibernate.dialect;

import java.sql.Types;

import org.hibernate.dialect.Oracle10gDialect;

/**
 * Overrides the default oracle10g dialect provided from hibernate to preserve
 * existing precision and scale informations for integer and long datatypes.
 *
 */
public class ConfigurableOracle10gDialect extends Oracle10gDialect {

	protected void registerNumericTypeMappings() {
		super.registerNumericTypeMappings();
		registerColumnType(Types.BIGINT, "number($p,0)");
		registerColumnType(Types.INTEGER, "number($p,0)");
	}

}
