package org.openxma.dsl.platform.hibernate.hql.impl;

import java.io.StringReader;

import org.hibernate.QueryException;
import org.openxma.dsl.platform.hibernate.hql.RewritingHqlLexerGen;

import antlr.Token;

public class RewritingHqlLexer extends RewritingHqlLexerGen {
	private boolean possibleID = false;

	public RewritingHqlLexer(StringReader stringReader) {
		super(stringReader);
	}

	@Override
	public void setTokenObjectClass(String cl) {
		super.setTokenObjectClass(HqlTokenWithIndex.class.getName());
	}

	protected void setPossibleID(boolean possibleID) {
		this.possibleID = possibleID;
	}

	protected Token makeToken(int i) {
		HqlTokenWithIndex token = (HqlTokenWithIndex) super.makeToken(i);
		token.setPossibleID(possibleID);
		possibleID = false;
		return token;
	}

	public void panic() {
		// overriden to avoid System.exit!
		panic("CharScanner: panic");
	}

	public void panic(String s) {
		// overriden to avoid System.exit!
		throw new QueryException(s);
	}

}
