package org.openxma.dsl.platform.valueobject;

public class ValueObjectLong extends ValueObjectComparable<Long> {

    private static final long serialVersionUID = 1L;

    public ValueObjectLong(Long value) {
        super(value);
    }

    public static ValueObjectLong newOrNull(Long value) {
        if (value != null) {
            return new ValueObjectLong(value);
        }
        return null;
    }

    public static ValueObjectLong newOrNull(String value) {
        if (value != null && value.length() > 0) {
            return new ValueObjectLong(Long.valueOf(value));
        }
        return null;
    }

}
