package org.openxma.dsl.platform.xma.client;

import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Text;
import org.eclipse.swt.widgets.Widget;


public class DslWidgetFactory extends DefaultWidgetFactory {
    
    protected static DslWidgetFactory instance;    
    
    /**
     * Returns an instance of the factory.
     *
     * @return an instance of WidgetFactory.
     */    
    public static synchronized DslWidgetFactory getInstance() {
        if (instance == null) {                        
            instance = new DslWidgetFactory();                            
        }
        return instance;
    }      
    
    /**
     * Create a text widget.
     * For the widgetVariant PASSWORD the SWT password style is set.
     */    
    public Text createText(Composite parent, int style, String widgetVariant) {
        if ("password".equals(widgetVariant)) {
            style = style | SWT.PASSWORD;
        }
        return super.createText(parent, style, widgetVariant);
    }
        
    /**
     * Set the RWT theme variant
     * 
     * @param widget
     * @param widgetVariant
     */
    protected void setThemeVariant(Widget widget, String widgetVariant) {
        String themeVariant = determineThemeVariantForWidgetVariant(widgetVariant);
        widget.setData("org.eclipse.rwt.themeVariant",themeVariant);        
        if (themeVariant != null) {
            widget.setData("org.eclipse.rwt.themeVariant",themeVariant);
        }
    }
    
    /**
     * Determine the RWT theme variant for a widget variant
     * 
     * @param widgetVariant
     * @return
     */
    protected String determineThemeVariantForWidgetVariant(String widgetVariant) {
        return null;
    }    

}
